"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNodeExecPathInNodeDir = exports.getNodeExecPathInBinDir = exports.getNodeExecPathAndTargetDir = exports.CURRENT_NODE_DIRNAME = void 0;
const fs_1 = require("fs");
const path_1 = __importDefault(require("path"));
exports.CURRENT_NODE_DIRNAME = 'nodejs_current';
async function getNodeExecPathAndTargetDir(pnpmHomeDir) {
    const nodePath = getNodeExecPathInBinDir(pnpmHomeDir);
    const nodeCurrentDirLink = path_1.default.join(pnpmHomeDir, exports.CURRENT_NODE_DIRNAME);
    let nodeCurrentDir;
    try {
        nodeCurrentDir = await fs_1.promises.readlink(nodeCurrentDirLink);
    }
    catch (err) {
        nodeCurrentDir = undefined;
    }
    return { nodePath, nodeLink: nodeCurrentDir ? getNodeExecPathInNodeDir(nodeCurrentDir) : undefined };
}
exports.getNodeExecPathAndTargetDir = getNodeExecPathAndTargetDir;
function getNodeExecPathInBinDir(pnpmHomeDir) {
    return path_1.default.resolve(pnpmHomeDir, process.platform === 'win32' ? 'node.exe' : 'node');
}
exports.getNodeExecPathInBinDir = getNodeExecPathInBinDir;
function getNodeExecPathInNodeDir(nodeDir) {
    return path_1.default.join(nodeDir, process.platform === 'win32' ? 'node.exe' : 'bin/node');
}
exports.getNodeExecPathInNodeDir = getNodeExecPathInNodeDir;
//# sourceMappingURL=utils.js.map